Subject: Re: [RFC PATCH v4 08/16] powerpc/8xx: Rework support for 8M pages using contiguous PTE entries

From: Oscar Salvador <[email-masked]>
Date: Wed, 29 May 2024 10:02:52 +0200

On Mon, May 27, 2024 at 03:30:06PM +0200, Christophe Leroy wrote:
> In order to fit better with standard Linux page tables layout, add
> support for 8M pages using contiguous PTE entries in a standard
> page table. Page tables will then be populated with 1024 similar
> entries and two PMD entries will point to that page table.
> 
> The PMD entries also get a flag to tell it is addressing an 8M page,
> this is required for the HW tablewalk assistance.
> 
> Signed-off-by: Christophe Leroy <[email-masked]>
> Reviewed-by: Oscar Salvador <[email-masked]>
> ---
...  
> +#define __HAVE_ARCH_HUGE_PTEP_GET
> +static inline pte_t huge_ptep_get(struct mm_struct *mm, unsigned long addr, pte_t *ptep)
> +{
> +	if (ptep_is_8m_pmdp(mm, addr, ptep))
> +		ptep = pte_offset_kernel((pmd_t *)ptep, 0);

Yes, you are right that this should have had the addr aligned down.

I can speak for others, but for me it is more clear to think of it this way:

1) check if ptep points to the first PMD entry for address
2) if it does, we know that the PMD describes a 8MB hugepage
3) return the PMD

That is why I thought that directly calling pmd_page_vaddr() gave a more clear
overview.

Now, feel free to ignore this if you think this is not clear or adds confusion,
I just wanted to give my insight reflecting on what I considered more
logical.

-- 
Oscar Salvador
SUSE Labs